
from basics import *
from numpy.oldnumeric.mlab import diff
from pgplot import *

import ZODB, ZODB.FileStorage, transaction
import persistent
from persistent.dict import *
from persistent.list import *
from BTrees.OOBTree import OOBTree
from BTrees.IOBTree import IOBTree

class SimpleFS:
   def __init__(self,fs,verb=0):
      self.fs = fs
      self.verb = verb
   def Clean(self):
      for g in glob(self.fs+"*"):
          if self.verb: print "Removing",g
          os.remove(g)
   def Open(self,readonly=False):
      self.storage = ZODB.FileStorage.FileStorage(self.fs,read_only=readonly)
      self.db = ZODB.DB(self.storage)
      self.conn = self.db.open()
      self.dbroot = self.conn.root()
      self.changed = False
      if self.verb:
         print "Found",list(self.dbroot.keys())
   def Read(self):
      self.data = {}
      for key in self.dbroot["Data"].keys():
          if self.verb: print "Reading",key
          self.data[key] = self.dbroot["Data"][key]
   def Add(self,key,data):
      if "Data" not in self.dbroot:
         if self.verb: print "Adding Data node"
         self.dbroot["Data"] = OOBTree()
         if self.verb: print "Committing add of Data node"
#         transaction.commit()
         if self.verb: print "Done committing add of Data node"
      if key in self.dbroot["Data"]:
         if self.verb: print "Deleting %s subnode" %(key)
         del self.dbroot["Data"][key]
         if self.verb: print "Committing delete of %s subnode" %(key)
#         transaction.commit()
         if self.verb: print "Done committing delete of %s subnode" %(key)
      if self.verb: print "Adding %s subnode" %(key)
      self.dbroot["Data"][key] = data
      if self.verb: print "Committing add of %s subnode" %(key)
#      transaction.commit()
      if self.verb: print "Done committing add of %s subnode" %(key)
      self.changed = True
   def Close(self):
      if self.changed: transaction.commit()
      self.db.close()
      self.conn.close()
      self.storage.close()


